## ros-foxy-tf2 0.13.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tf2)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(ament_cmake)
find_package(console_bridge_vendor REQUIRED) # Provides console_bridge 0.4.0 on platforms without it.
find_package(console_bridge REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(rcutils REQUIRED)

# export user definitions

#CPP Libraries
add_library(tf2 SHARED src/cache.cpp src/buffer_core.cpp src/static_cache.cpp src/time.cpp)
target_include_directories(tf2 PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/bt>"
  "$<INSTALL_INTERFACE:include>")
ament_target_dependencies(tf2
  "console_bridge"
  "geometry_msgs"
  "rcutils"
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(tf2 PRIVATE "TF2_BUILDING_DLL")

install(TARGETS tf2 EXPORT tf2
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)

# Tests
if(BUILD_TESTING)
  # TODO(tfoote) enable linters
  # find_package(ament_lint_auto REQUIRED)
  # ament_lint_auto_find_test_dependencies()
  find_package(ament_cmake_gtest)

  ament_add_gtest(test_cache_unittest test/cache_unittest.cpp)
  if(TARGET test_cache_unittest)
    target_link_libraries(test_cache_unittest tf2)
    ament_target_dependencies(test_cache_unittest
      "geometry_msgs"
      "console_bridge"
    )
  endif()

  ament_add_gtest(test_static_cache_unittest test/static_cache_test.cpp)
  if(TARGET test_static_cache_unittest)
    target_link_libraries(test_static_cache_unittest tf2)
    ament_target_dependencies(test_static_cache_unittest
      "geometry_msgs"
      "console_bridge"
    )
    target_link_libraries(test_static_cache_unittest tf2 ${geometry_msgs_LIBRARIES} ${console_bridge_LIBRARIES})
  endif()

  ament_add_gtest(test_simple test/simple_tf2_core.cpp)
  if(TARGET test_simple)
    target_link_libraries(test_simple tf2)
    ament_target_dependencies(test_simple
      "geometry_msgs"
      "console_bridge"
    )
  endif()

  ament_add_gtest(test_time test/test_time.cpp)
  if (TARGET test_time)
    target_link_libraries(test_time tf2)
  endif()

# TODO(tfoote) reimplement speed test without dependency on message datatypes.
# add_executable(speed_test EXCLUDE_FROM_ALL test/speed_test.cpp)
# target_link_libraries(speed_test tf2  ${geometry_msgs_LIBRARIES} ${console_bridge_LIBRARIES})
# add_dependencies(tests speed_test)

endif()

ament_export_dependencies(console_bridge geometry_msgs rcutils)
ament_export_include_directories(include)
ament_export_libraries(tf2)
ament_export_targets(tf2)
ament_package()

=== debian/changelog ===
ros-foxy-tf2 (0.13.14-1focal) focal; urgency=high

  * Include required header Scalar.h (#559 <https://github.com/ros2/geometry2/issues/559>) (#564 <https://github.com/ros2/geometry2/issues/564>)
  * Contributors: mergify[bot], Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-tf2 (0.13.13-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-tf2 (0.13.12-1focal) focal; urgency=high

  * Workaround with pragma push and pop for NO_ERROR collison (#456 <https://github.com/ros2/geometry2/issues/456>)
  * Contributors: Lior Lustgarten

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 05 Oct 2021 00:00:00 -0000

ros-foxy-tf2 (0.13.11-1focal) focal; urgency=high

  * Fix a TOCTTOU race in tf2 (#307 <https://github.com/ros2/geometry2/issues/307>) (#449 <https://github.com/ros2/geometry2/issues/449>)
  * Contributors: Chris Lalancette, Louise Poubel

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 31 Aug 2021 00:00:00 -0000

ros-foxy-tf2 (0.13.10-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-tf2 (0.13.9-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.8-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 08 Dec 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.7-1focal) focal; urgency=high

  * [Foxy backport] Fixed memory leak in Buffer::waitForTransform (#281 <https://github.com/ros2/geometry2/issues/281>) (#330 <https://github.com/ros2/geometry2/issues/330>)
  * Contributors: Matthijs den Toom

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 18 Nov 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.6-1focal) focal; urgency=high

  * [Foxy backport] Add PoseWithCovarianceStamped transform support (#336 <https://github.com/ros2/geometry2/issues/336>)
  * Update maintainers of the ros2/geometry2 fork. (#328 <https://github.com/ros2/geometry2/issues/328>) (#332 <https://github.com/ros2/geometry2/issues/332>)
  * Contributors: Alejandro Hernández Cordero, Nikolai Morin

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 28 Oct 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.5-1focal) focal; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 05 Aug 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.4-1focal) focal; urgency=high

  * Add missing virtual destructors (#272 <https://github.com/ros2/geometry2/issues/272>)
  * Contributors: Ivan Santiago Paunovic

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 03 Jun 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.3-1focal) focal; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.2-1focal) focal; urgency=high

  * Modify error message to not match the pattern for Jenkins MSBuild errors (#265 <https://github.com/ros2/geometry2/issues/265>)
  * Contributors: Dirk Thomas

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 18 May 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.1-1focal) focal; urgency=high

  * export modern CMake interface target (#263 <https://github.com/ros2/geometry2/issues/263>)
  * Contributors: Dirk Thomas

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-tf2 (0.13.0-1focal) focal; urgency=high

  * Added doxyfiles and sphinx Makefiles (#257 <https://github.com/ros2/geometry2/issues/257>)
  * Fix displayTimePoint truncation error (#253 <https://github.com/ros2/geometry2/issues/253>)
  * rename rosidl_generator_cpp namespace to rosidl_runtime_cpp (#248 <https://github.com/ros2/geometry2/issues/248>)
  * Use the new rcutils_strerror function. (#239 <https://github.com/ros2/geometry2/issues/239>)
  * Remove unnecessary semicolons. (#235 <https://github.com/ros2/geometry2/issues/235>)
  * Export all tf2 dependencies. (#238 <https://github.com/ros2/geometry2/issues/238>)
  * Fix a deprecated copy warning by implementing the assignment operator (#201 <https://github.com/ros2/geometry2/issues/201>)
  * tf2 add windows cmath constants (#217 <https://github.com/ros2/geometry2/issues/217>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Dirk Thomas, Hunter L. Allen, Michel Hidalgo, brawner

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 30 Apr 2020 00:00:00 -0000

ros-foxy-tf2 (0.12.4-1focal) focal; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 19 Nov 2019 00:00:00 -0000

ros-foxy-tf2 (0.12.3-1focal) focal; urgency=high

  * Provide more available error messaging for nonexistent and invalid frames in canTransform (#187 <https://github.com/ros2/geometry2/issues/187>)
  * Contributors: Emerson Knapp

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 18 Nov 2019 00:00:00 -0000

ros-foxy-tf2 (0.12.2-1focal) focal; urgency=high

  * Fix up -Wcast-qual warning (#193 <https://github.com/ros2/geometry2/issues/193>) (#197 <https://github.com/ros2/geometry2/issues/197>)
  * Contributors: Chris Lalancette

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 18 Nov 2019 00:00:00 -0000

ros-foxy-tf2 (0.12.1-1focal) focal; urgency=high

  * Overwrite TimeCacheInterface type with a current input (#151 <https://github.com/ros2/geometry2/issues/151>)
  * [tf2] Use ament_target_dependencies where possible
  * Restore conversion via message traits (#167 <https://github.com/ros2/geometry2/issues/167>)
  * Contributors: Jacob Perron, Michael Carroll, Vinnam Kim

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-tf2 (0.12.0-1focal) focal; urgency=high

  * Add pure virtual interface tf2::BufferCoreInterface
  * Guard against invalid iterator (#127 <https://github.com/ros2/geometry2/issues/127>)
  * Contributors: Jacob Perron

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 26 Sep 2019 00:00:00 -0000

ros-foxy-tf2 (0.11.3-1focal) focal; urgency=high





=== debian/control ===
Source: ros-foxy-tf2
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libconsole-bridge-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-console-bridge-vendor, ros-foxy-geometry-msgs, ros-foxy-rcutils, ros-foxy-ros-workspace
Homepage: http://www.ros.org/wiki/tf2
Standards-Version: 3.9.2

Package: ros-foxy-tf2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libconsole-bridge-dev, ros-foxy-console-bridge-vendor, ros-foxy-geometry-msgs, ros-foxy-rcutils, ros-foxy-ros-workspace
Description: tf2 is the second generation of the transform library, which lets the user keep track of multiple coordinate frames over time.
 tf2 maintains the relationship between coordinate frames in a tree structure buffered in time, and lets the user transform points, vectors, etc between any two coordinate frames at any desired point in time.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-tf2//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
